// C Source File
// Created 05/02/05; 00:41:15

#include <tigcclib.h>
#include "opale.h"

t_SEMAPHORE sem1;
t_MAILBOX mb1;

void counterTaskFunc( register void* args asm("%a0") )
{
	for( ;; )
	{
		op_SemaphorePend( &sem1 );
		(*(unsigned short*)args) ++;	
	}
}

void readerTaskFunc( register void* args asm("%a0") )
{
unsigned short i;
char sbuffer[30];

	for( ;; )
	{
		op_SemaphorePost( &sem1 );	
		
	  i = *(unsigned short*)args;
	  
	  op_EnterCriticalSection();
	 	sprintf( sbuffer, "count: %d", i);
		DrawStr (10, 10, sbuffer, A_REPLACE);
		op_ExitCriticalSection();
		
		if( i == 10 )
			op_MailBoxPost( &mb1, (void*)1 );

		op_TaskWaitForTicks( 20 );
		
	}	
}

void testTaskFunc( register void* args asm("%a0") )
{
char i = (long)args;
unsigned short count = 0;
char sbuffer[30];

	for( ;; )
	{
		op_EnterCriticalSection();
		sprintf( sbuffer, "%d - %d", i, count ++ );
		DrawStr (10, 10+10*i, sbuffer, A_REPLACE);
		op_ExitCriticalSection();
	}
}


void killerTaskFunc( register void* args asm("%a0") )
{
	args = args;

	op_MailBoxPend( &mb1 );
	op_KernelStop();
}

// Main Function
void _main(void)
{

t_TASK readerTask,counterTask,testTask,testTask2,killerTask;

t_op_BUFFER buffer;

char readerTaskStack[ 500 ];
char counterTaskStack[ 200 ];

char testTaskStack2[ 500 ];
char testTaskStack[ 500 ];

char killerTaskStack[ 200 ];

char sbuffer[30];

unsigned short i = 0;

	sprintf( sbuffer, "NUM_TASKS: %d", NUM_TASKS);
	DrawStr (10, 50, sbuffer, A_REPLACE);
	
	// autorise le groupe de niveau 0 (bit 0 de l'argument  1)  avoir des priorits tournantes 
	op_KernelInit( &buffer, 1 );

	op_SemaphoreInit( &sem1, 0 );
	op_MailBoxInit( &mb1, NULL );

	op_TaskStart( &testTask, testTaskFunc, &testTaskStack[ 500 ], 1, (void*)1 );
	op_TaskStart( &testTask2, testTaskFunc, &testTaskStack2[ 500 ], 2, (void*)2 );

	op_TaskStart( &readerTask, readerTaskFunc, &readerTaskStack[ 500 ], 0, &i );
	op_TaskStart( &counterTask, counterTaskFunc, &counterTaskStack[ 200 ], 4, &i );

	op_TaskStart( &killerTask, killerTaskFunc, &killerTaskStack[ 200 ], 5, NULL );

	op_KernelStart();

}


/* end of file */
