; Assembly Source File
; Created 07/02/05, 18:45:54

	xdef op_KernelStop
	xdef op_KernelStart
	
	xdef op_idleCounter
	
	xdef IdleTaskFunction
	xdef InitStack
	xdef ContextSwitch
	
	xdef currentTask
	xdef sspSave

 section currentTask
currentTask:
	ds.l	1
	
 section sspSave
sspSave:
	ds.l	1
		
 section ContextSwitch
ContextSwitch:

	move.l	sspSave(pc),a1		; a1 is pointing to the SR and return adress of current interrupt
	move.l	usp,a0			; a0 is pointing to the current task's stack
	move.w	(a1)+,-(a0)		; loads interrupted SR on the task's stack
	move.l	(a1)+,-(a0)		; loads interrupted PC on the task's stack
	
	move.l	(a2),a4			; a2 points to current task's object
	move.l	a3,(a2)			; set it as current task
	
	move.l	a0,(a4)			; saves current task's stack pointer

	move.l	(a3),a0			; a0 is now the new current task's stack pointer
	
	move.l	(a0)+,-(a1)		; stores the return adress in supervisor stack
	move.w	(a0)+,-(a1)		; stores return SR
	move.l	a0,usp			; load new actual stack pointer
	
	rts				; return
	
 section InitStack
; void imk_InitStack( register void* args asm("%a0"), register char* stack asm("%a1"), register void(*func)() asm("%a2") );
InitStack:

	exg	a1,a7
	
	movem.l	d0-a6,-(a7)
	move.w	sr,-(a7)	; fake sr
	move.l	a2,-(a7)	; push func
	
	exg	a1,a7
	move.l	a1,a0
	
	rts

 section exitSP
exitSP:
	ds.l	1

 section op_KernelStart
op_KernelStart:

	movem.l	d0-a6,-(a7)
	
	lea.l	idleTask(pc),a0
	move.l	a0,currentTask			;currentTask = &idleTask;

	move.l	a7,exitSP			; saves SP

	move.l	(a0),a7
	
	addq.l	#6,a7

	movem.l	(a7)+,d0-a6
	
	lea.l	op_idleCounter(pc),a0
	
	clr.l	(a0)
	move.l	(a0),op_tickCounter
	move.w	(a0),numberOfNestedShedulerHalts	; numberOfNestedShedulerHalts = 0;
	move.w	#1,kernelStarted
	trap	#6				; calls scheduler
		
IdleTaskFunction:
	addq.l	#1,op_idleCounter
	bra.s	IdleTaskFunction					; wait for the first tick

 section op_idleCounter:
op_idleCounter:
	ds.l	1
	
 section op_KernelStop
op_KernelStop:

	trap #7			;op_EnterCriticalSection();

	move.l	exitSP(pc),a7	; restores sp
	movem.l	(a7)+,d0-a6	; restores regs
	
	bra	RestoreIntVectors(pc)

;	never returns

