// Header File
// Created 07/02/05; 20:01:55

#include <tigcclib.h>

#include "opale.h"

#define MASK_X (_X_-1)
#define MASK_Y (_N_)

#define IDLE_TASK_PRIORITY LOWEST_PRIORITY
#define IDLE_TASK_IDENT IDLE_TASK_PRIORITY

#define indexToSettedBit(_itsb) (1<<(_itsb))
#define indexToUnsettedBit(_itub) (~(1<<(_itub)))

#define identToX(_itx) ((_itx)&MASK_X)
#define identToY(_ity) ((_ity)>>MASK_Y)

#define op_Scheduler() asm(" trap #6")

typedef struct 
{
	unsigned long	value;
	t_TASK_BLOCK waitingTasks;
} t_EVENT;

void InitIntVectors( void );
void RestoreIntVectors( void );

void addTaskToTable( register t_TASK_BLOCK* table asm("%a0"), register unsigned char ident asm("%d0")  );
void removeTaskFromTable( register t_TASK_BLOCK* table asm("%a0"), register unsigned char ident asm("%d0")  ) ;

void IdleTaskFunction( register void* asm("%a0") ) __attribute__ ((noreturn));

void ContextSwitch( register t_TASK* highestPriorityTaskReady asm("%a3"), register t_TASK** currentTask asm("%a2") ) __attribute__ ((noreturn));
void* InitStack( register void* args asm("%a0"), register char* stack asm("%a1"), register void(*func)() asm("%a2") );

extern unsigned short numberOfNestedISRs;
extern unsigned short numberOfNestedShedulerHalts;

//extern t_TASK* highestPriorityTaskReady;
extern t_TASK* currentTask;
extern t_TASK idleTask;

extern t_TASK** runningTasks;
extern t_TASK_BLOCK* readyTasks;

//extern unsigned char* readyTasksTable;
//extern unsigned short readyTasksRowIndex;
extern t_TASK_BLOCK* waitingTasks;
extern unsigned char* indexToLowestSettedBit;

