; Assembly Source File
; Created 19/02/2005, 22:01:43

	xdef InitIntVectors	
	xdef RestoreIntVectors
	xdef op_tickCounter

op_tickCounter:
	ds.l	1

 section TickerISR
TickerISR:
; auto int 5

	move.w	#$2700,sr
	
	tst.w	numberOfNestedShedulerHalts
	bne.s	exit_TickerISR(pc)
	
	move.l	a7,sspSave
	move.l	usp,a7
	movem.l	d0-a6,-(a7)
	move.l	a7,usp
	move.l	sspSave(pc),a7

	bsr	PerformDelay(pc)
	bsr	Scheduler(pc)

	move.l	usp,a7
	movem.l	(a7)+,d0-a6
	move.l	a7,usp
	move.l	sspSave(pc),a7
	
exit_TickerISR:

	move.l	oldAutoInt5(pc),-(a7)
	rts

	
SchedulerISR:
; trap 6

	move.w	#$2700,sr
	tst.w	kernelStarted
	beq.s	exit_SchedulerISR(pc)
	
	move.l	a7,sspSave
	move.l	usp,a7
	movem.l	d0-a6,-(a7)
	move.l	a7,usp
	move.l	sspSave(pc),a7

	bsr	Scheduler(pc)

	move.l	usp,a7
	movem.l	(a7)+,d0-a6
	move.l	a7,usp
	move.l	sspSave(pc),a7
	
exit_SchedulerISR:
	
	rte

 section EnterCriticalSectionISR
EnterCriticalSectionISR:
; trap 7
	addq.l	#1,numberOfNestedShedulerHalts
	rte

 section ExitCriticalSectionISR
ExitCriticalSectionISR:
; trap 8
	subq.l	#1,numberOfNestedShedulerHalts
	rte
	
	
 section oldVectors
oldVectors:
oldTrap6:
	ds.l	1
oldTrap7:
	ds.l	1
oldTrap8:
	ds.l	1
oldAutoInt5:
	ds.l	1

 section InitIntVectors
InitIntVectors:

	move.w	#$0700,d0
	trap	#1		; de-activate ints
	
	movea.l	#$600001,a0	; low memory unprotection port
	lea.l	($0098).w,a1	; adress to vectors
	
	lea	oldVectors(pc),a2
	
	bclr.b	#2,(a0)		; unprotect low memory

	move.l	(a1),(a2)+			; saves to oldTrap6
	move.l	#SchedulerISR,(a1)+		; trap 6
	
	move.l	(a1),(a2)+			; saves to oldTrap7
	move.l	#EnterCriticalSectionISR,(a1)+	; trap 7	
	
	move.l	(a1),(a2)+			; saves to oldTrap8
	move.l	#ExitCriticalSectionISR,(a1)	; trap 8

	move.l	-44(a1),(a2)+			; saves to oldAutoInt5
	move.l	#TickerISR,-44(a1)		; auto int 5

	bset.b	#2,(a0)

	trap	#1

	rts
	
 section RestoreIntVectors
RestoreIntVectors:

	move.w	#$0700,d0
	trap	#1		; de-activate ints
	
	movea.l	#$600001,a0	; low memory unprotection port
	lea.l	($0098).w,a1	; adress to vectors
	
	lea.l	oldVectors(pc),a2
	
	bclr.b	#2,(a0)		; unprotect low memory

	move.l	(a2)+,(a1)+			; restores Trap6
	move.l	(a2)+,(a1)+			; restores Trap7	
	move.l	(a2)+,(a1)			; restores Trap8
	move.l	(a2)+,-44(a1)			; restores Auto Int5

	bset.b	#2,(a0)
	
	trap	#1

	rts
 
 
 
 
 